<template>
	<el-dialog v-model="state.dialogVisible" draggable title="服务企业查找" ref="dialogRef" append-to-body destroy-on-close>
		<el-form :model="state.queryParams" ref="ruleFormRef" inline @submit.native.prevent>
			<el-form-item label="关键词" prop="Keyword">
				<el-input v-model="state.queryParams.Keyword" placeholder="企业名称" clearable @keyup.enter="handleQuery" />
			</el-form-item>
			<el-form-item>
				<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
				<el-button @click="resetQuery(ruleFormRef)" class="default-button" :loading="state.loading">
					<SvgIcon name="ele-Refresh" class="mr5" />重置
				</el-button>
			</el-form-item>
		</el-form>
		<ProTable
			ref="proTableRef"
			:columns="columns"
			:data="state.tableData"
			@updateTable="queryList"
			:loading="state.loading"
			:total="state.total"
			v-model:page-index="state.queryParams.PageIndex"
			v-model:page-size="state.queryParams.PageSize"
			v-model:radio="tableRadio"
			@current-change="handleSelectionChange"
		>
		</ProTable>
		<template #footer>
			<span class="dialog-footer">
				<el-button class="default-button" @click="state.dialogVisible = false">取 消</el-button>
				<el-button type="primary" @click="selectConfirm" :disabled="!tableRadio">确 定</el-button>
			</span>
		</template>
	</el-dialog>
</template>

<script setup lang="tsx" name="orderCompanySearch">
import { reactive, ref } from 'vue';
import type { FormInstance } from 'element-plus';
import { companyInfo } from '@/api/business/order';
import { useRoute } from 'vue-router';

const proTableRef = ref<RefType>(); // 表格ref
// 表格配置项
const columns = ref<any[]>([
	{ type: 'radio', fixed: 'left', width: 80, label: '请选择' },
	{ prop: 'enterpriseName', label: '企业名称' },
	{ prop: 'specialTeamCode', label: '专班名称' },
]);
// 引入组件
const emit = defineEmits(['saveSelect']);
// 定义变量内容
const state = reactive<any>({
	dialogVisible: false, // 弹窗显示隐藏
	queryParams: {
		PageIndex: 1, // 当前页
		PageSize: 10, // 每页条数
		Keyword: null, // 关键字
	},
	tableData: [], // 表格数据
	total: 0, // 总条数
	loading: false, // 加载状态
});
const ruleFormRef = ref<RefType>(); // 表单ref
const tableRadio = ref<String>(''); // 选择的单选框
const selectRow = ref<EmptyObjectType>({}); // 选择的行
const route = useRoute(); // 路由
// 打开弹窗
const openDialog = () => {
	queryList();
	state.dialogVisible = true;
};
const dialogRef = ref<RefType>();
// 关闭弹窗
const closeDialog = () => {
	state.dialogVisible = false;
};
/** 搜索按钮操作 */
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	queryList();
};
/** 重置按钮操作 */
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	handleQuery();
};
/** 获取历史工单 */
const queryList = () => {
	state.loading = true;
	let request = {
		...state.queryParams,
	};
	companyInfo(request)
		.then((response: any) => {
			state.tableData = response?.result.items ?? [];
			state.total = response?.result.total;
			state.loading = false;
		})
		.catch(() => {
			state.loading = false;
		});
};
// 选择企业
const handleSelectionChange = (row: any) => {
	if (row) {
		tableRadio.value = row.id;
		selectRow.value = row;
	}
};
// 确定选择历史工单
const selectConfirm = () => {
	emit('saveSelect', selectRow.value);
};
// 暴露变量
defineExpose({
	openDialog,
	closeDialog,
});
</script>
